/*****************
* 16F687 Dryer Minder
*
******************/
#include <htc.h>
#define _XTAL_FREQ 8000000
// #define RUNSECONDS 1200
#define BUZZSECONDS 4

__CONFIG (FOSC_LP & WDTE_OFF & PWRTE_OFF & MCLRE_OFF & CP_OFF  & BOREN_OFF & IESO_OFF & FCMEN_OFF);

static void interrupt isr(void);
void SoundBuzz(unsigned char);
void TimerConfig(void);
unsigned char intDryer;
unsigned char intTimer;
unsigned int RunSeconds;
unsigned int tRunning;	// elapsed run. 1200 seconds in 20 min.
 
main()
{

OSCCONbits.SCS = 1;	// CPU uses internal (RC) clock
TRISA = 0b00000100; // pin RA2 as input
ANSEL = 0x00;		// A to D off
ANSELH = 0x00;	
INTEDG = 0;			// enable int on falling

TRISB = 0x00; 		// RB6 is buzzer output		 
TRISC = 0b00000001;  		
OPTION_REG = 0xC0;
SoundBuzz (2);		// sound buzzer when powered up
PORTB = 0x00;
RunSeconds = 60;

TimerConfig();
intDryer = 0;
intTimer = 0;

GIE = 1;


while (1)
{
INTE = 1;
// SLEEP(); 
NOP();
NOP();
PORTCbits.RC7 = 1;	//turn on heartbeat LED


if (PORTAbits.RA2 == 1) { 	tRunning = 0; }			// reset elapsed timer
				
else	
	{  
			tRunning++;  				// increment elapsed
	    if ((tRunning % 5) == 0)
		 { PORTCbits.RC6 = 1; __delay_ms(100);  } // In Cycle LED

		if (tRunning == (60-BUZZSECONDS))
					 { PORTBbits.RB6 = 1; }   // buzzer on
		if (tRunning == 60)  
					 { PORTBbits.RB6 = 0; } // buzzer off 	  
		}
	

__delay_ms(10);	
intDryer = 0;
intTimer = 0;

PORTCbits.RC6 = 0;	// in cycle LED off
PORTCbits.RC7 = 0;	//turn off heartbeat LED
}
		
}  // end of main




static void interrupt isr(void)
{


if (TMR1IF) 	// Int from timer
{	intTimer = 1;
	TMR1H = 0x80;
    TMR1IF = 0; }

if (INTF)		// INT from key
{ 	intDryer = 1;
	INTF = 0; } 

 return;
}


void SoundBuzz(char num)
{
	unsigned char i;
	for (i=1; i < num; i++)
	{
	PORTBbits.RB6 = 1;
	__delay_ms(200);
	PORTBbits.RB6 = 0;
	__delay_ms(200);
	}
}   // end of SoundBuzz


void TimerConfig (void)
{           	// timer config
T1CON = 0;
T1OSCEN = 1;  	// turn on internal osc
TMR1CS	= 1;
nT1SYNC = 1;
TMR1L = 0;
TMR1H = 0x80;
TMR1IE = 1;
PEIE   = 1;	
TMR1ON = 0;	// DEBUG no timer
}